package ru.dbotthepony.mc.otm.block

import net.minecraft.core.BlockPos
import net.minecraft.world.level.BlockGetter
import net.minecraft.world.level.Level
import net.minecraft.world.level.block.Block
import net.minecraft.world.level.block.EntityBlock
import net.minecraft.world.level.block.entity.BlockEntity
import net.minecraft.world.level.block.entity.BlockEntityTicker
import net.minecraft.world.level.block.entity.BlockEntityType
import net.minecraft.world.level.block.state.BlockState
import net.minecraft.world.level.material.Material
import net.minecraft.world.level.material.MaterialColor
import net.minecraft.world.phys.shapes.CollisionContext
import net.minecraft.world.phys.shapes.VoxelShape
import ru.dbotthepony.mc.otm.Registry
import ru.dbotthepony.mc.otm.block.entity.BlockEntityBlackHole
import ru.dbotthepony.mc.otm.shapes.BlockShapes

class BlockBlackHole :
	Block(Properties.of(Material.Builder(MaterialColor.COLOR_BLACK).noCollider().nonSolid().build()).strength(-1f, 7200000.0f)), EntityBlock {
	override fun getShape(
		p_60555_: BlockState,
		p_60556_: BlockGetter,
		p_60557_: BlockPos,
		p_60558_: CollisionContext
	): VoxelShape {
		return SHAPE
	}

	override fun newBlockEntity(blockPos: BlockPos, blockState: BlockState): BlockEntity {
		return BlockEntityBlackHole(blockPos, blockState)
	}

	override fun <T : BlockEntity?> getTicker(
		p_153212_: Level,
		p_153213_: BlockState,
		p_153214_: BlockEntityType<T>
	): BlockEntityTicker<T>? {
		if (p_153214_ !== Registry.BlockEntities.BLACK_HOLE) return null

		return if (p_153212_.isClientSide) BlockEntityTicker { level: Level, blockPos: BlockPos, blockState: BlockState, t: T ->
			BlockEntityBlackHole.clientTicker(
				level,
				blockPos,
				blockState,
				t
			)
		} else BlockEntityTicker { level: Level, blockPos: BlockPos, blockState: BlockState, t: T ->
			BlockEntityBlackHole.ticker(
				level,
				blockPos,
				blockState,
				t
			)
		}
	}

	companion object {
		private val SHAPE = BlockShapes.BLACK_HOLE.computeShape()
	}
}