package ru.dbotthepony.mc.otm.block

import net.minecraft.core.BlockPos
import net.minecraft.world.Containers
import net.minecraft.world.item.context.BlockPlaceContext
import net.minecraft.world.level.Level
import net.minecraft.world.level.block.Block
import net.minecraft.world.level.block.EntityBlock
import net.minecraft.world.level.block.entity.BlockEntity
import net.minecraft.world.level.block.state.BlockState
import net.minecraft.world.level.block.state.StateDefinition
import net.minecraft.world.level.block.state.properties.BooleanProperty
import ru.dbotthepony.mc.otm.block.entity.BlockEntityCargoCrate

class BlockCargoCrate : BlockMatteryRotatable(), EntityBlock {
	override fun newBlockEntity(blockPos: BlockPos, blockState: BlockState): BlockEntity? {
		return BlockEntityCargoCrate(blockPos, blockState)
	}

	override fun createBlockStateDefinition(builder: StateDefinition.Builder<Block, BlockState>) {
		super.createBlockStateDefinition(builder)
		builder.add(IS_OPEN)
	}

	override fun getStateForPlacement(context: BlockPlaceContext): BlockState? {
		return super.getStateForPlacement(context)!!.setValue(IS_OPEN, false)
	}

	override fun onRemove(
		old_block_state: BlockState,
		level: Level,
		block_pos: BlockPos,
		new_block_state: BlockState,
		p_51542_: Boolean
	) {
		if (!old_block_state.`is`(new_block_state.block)) {
			val blockentity = level.getBlockEntity(block_pos)

			if (blockentity is BlockEntityCargoCrate) {
				Containers.dropContents(level, block_pos, blockentity.container);
				level.updateNeighbourForOutputSignal(block_pos, this);
			}

			super.onRemove(old_block_state, level, block_pos, new_block_state, p_51542_)
		}
	}

	companion object {
		@JvmField
		val IS_OPEN = BooleanProperty.create("open")
	}
}